function isQueryISupportsArray(supportsArray,iid) 
{
     var result = new Array;
     for (var i=0; i<supportsArray.Count(); i++) {
       // dump(i + "," + result[i] + "\n");
       result[i] = supportsArray.QueryElementAt(i, iid);
     }
     return result;
}

function ContextSensitiveSendMessage(event)
{
    var selIdent = null;
    var folderTree = GetFolderTree();
    var folderSelection = folderTree.view.selection;

    var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);

    if(folderSelection.count > 0)
    {
	var startIndex = {};
	var endIndex = {};

	folderSelection.getRangeAt(0, startIndex, endIndex);
	var folderResource = GetFolderResource(folderTree, startIndex.value);
	var uri = folderResource.Value;

        // get the incoming server associated with this uri
	var resource = RDF.GetResource(uri);
  	var msgfolder = resource.QueryInterface(Components.interfaces.nsIMsgFolder);
        var server = msgfolder.server;

	// get the identity associated with this server
	var identities = accountManager.GetIdentitiesForServer(server);

	// just get the first one
	if (identities.Count() > 0 ) 
	{
	    selIdent = identities.GetElementAt(0).QueryInterface(Components.interfaces.nsIMsgIdentity);  
	}
    }

    var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"].getService();
    msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
    msgComposeService.OpenComposeWindow(null, null,
	                                Components.interfaces.nsIMsgCompType.New,
                                        Components.interfaces.nsIMsgCompFormat.Default,
                                        selIdent, null);

}

function PerformSelectedCompose(event,item)
{
        var selIdent;

        var gAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);

        var accounts = isQueryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);

        // accounts.sort(compareAccountSortOrder); TODO!!

        for (var i in accounts) {
            var server = accounts[i].incomingServer;
            if (!server)
                continue;

            var identites = isQueryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);

            for (var j in identites) {
                 var identity = identites[j];
                 if( identity.key == item.value )
                 {
                     selIdent = identity;
                 }
            }
        }

	var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"].getService();
 	msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
	msgComposeService.OpenComposeWindow(null, null,
	                                    Components.interfaces.nsIMsgCompType.New,
                                            Components.interfaces.nsIMsgCompFormat.Default,
                                            selIdent, null);
}

function FillWithPotentialIdentities()
{
    var gAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);

    var accounts = isQueryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);

    // accounts.sort(compareAccountSortOrder); TODO!!

    var menupopup = document.getElementById('identPopup');

    for(var i=menupopup.childNodes.length - 1; i>=0; i--) {
        menupopup.removeChild(menupopup.childNodes.item(i));
    }

    for (var i in accounts) {
        var server = accounts[i].incomingServer;
        if (!server)
            continue;

        var identites = isQueryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);

        for (var j in identites) {
             var identity = identites[j];
             var child = document.createElement("menuitem");
             child.setAttribute("label",identity.identityName);
             child.setAttribute("value",identity.key);
             child.setAttribute("oncommand","PerformSelectedCompose(event,this);  event.preventBubble();");
             menupopup.appendChild(child);
        }
    }
}
